# -*- rpm-spec -*-
%define module_name	anbox
# use debian numeration
%define module_version  14
%define git ae26ba2

#### MODULE SOURCES ####
Name: kernel-source-%module_name
Version: %module_version
Release: alt6.g%{git}
Provides: kernel-source-%module_name-%module_version
Summary: Anbox kernel modules sources
License: GPLv3/GPLv2
Group: Development/Kernel
Url: http://github.com/anbox/anbox-modules
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Source0: %name-%version.tar

BuildPreReq: kernel-build-tools
BuildArch: noarch

%description
Anbox kernel modules sources.

%package -n anbox-kernel-conf
Group: System/Kernel and hardware
Summary: Anbox kernel modules configuration
BuildArch: noarch

%description -n anbox-kernel-conf
Configuration for anbox kernel modules.

%prep
%setup -c -q

%install
# ashmem_linux non needed for kernels >= 5.18
sed -i -e '/^ashmem_linux/d' %name-%version/anbox.conf
install -m644 -pD %name-%version/anbox.conf %buildroot%_sysconfdir/modules-load.d/anbox.conf
install -m644 -pD %name-%version/99-anbox.rules %buildroot%_udevrulesdir/99-anbox.rules

mkdir -p %kernel_srcdir
tar jcf %kernel_srcdir/%name-%version.tar.bz2 %name-%version

%files
%attr(0644,root,root) %kernel_src/%name-%version.tar.bz2

%files -n anbox-kernel-conf
%_sysconfdir/modules-load.d/anbox.conf
%_udevrulesdir/99-anbox.rules

%changelog
* Fri Jul 04 2025 L.A. Kostis <lakostis@altlinux.ru> 14-alt6.gae26ba2
- Added MODULE_DESCRIPTION: required in 6.15+
- Apply upstream cleanups:
  + binder: remove unneeded <linux/export.h> inclusion from binder_internal.h
- Apply upstream fixes:
  + binder: fix race between mmput() and do_exit()
- Apply fixes from kernel 6.13:
  + binder_alloc: (mm/list_lru: simplify the list_lru walk callback function)
- Apply fixes from kernel 6.14:
  + binder: lsm: (ensure the correct LSM context releaser)

* Wed Jun 05 2024 L.A. Kostis <lakostis@altlinux.ru> 14-alt5.gae26ba2
- Apply fixes from kernel 6.9:
  + binder_alloc: list_lru_{add,del}->list_lru_{add,del}_obj
- Apply fixes for kernels 6.8+:
  + binder: s/close_fd_get_file()/file_close_fd()/g
- Apply fixes for kernels 6.7+:
  + binder_alloc: fix use-after-free in shinker's callback
  + binder_alloc: dynamically allocate the android-binder shrinker
  + binderfs: Convert to using the new inode timestamp accessor functions.

* Sun Dec 03 2023 L.A. Kostis <lakostis@altlinux.ru> 14-alt4.gae26ba2
- Apply fixes from kernel-6.6:
  + binderfs: Drop unused #include <linux/radix-tree.h>
  + binder: fix memory leak in binder_init()
  + binder: fix UAF of alloc->vma in race with munmap()
  + binderfs: convert to ctime accessor functions

* Wed Sep 13 2023 L.A. Kostis <lakostis@altlinux.ru> 14-alt3.gae26ba2
- udev.rules: remove useless macros.

* Thu Jun 01 2023 L.A. Kostis <lakostis@altlinux.ru> 14-alt2.gae26ba2
- Apply fixes to compile with 6.3+ kernel.

* Fri Mar 31 2023 L.A. Kostis <lakostis@altlinux.ru> 14-alt1.gae26ba2
- Updated to GIT ae26ba2 from choff.

* Fri Mar 31 2023 L.A. Kostis <lakostis@altlinux.ru> 13-alt1.g98f0f3b
- Initial build for ALTLinux.
